// DlgUpgrade.cpp : ʵļ
//

#include "stdafx.h"
#include "AjNetSdkDemo.h"
#include "NetSDKDevice.h"
#include "DlgUpgrade.h"
#include "afxdialogex.h"


// CDlgUpgrade Ի

IMPLEMENT_DYNAMIC(CDlgUpgrade, CDialogEx)

CDlgUpgrade::CDlgUpgrade(CWnd* pParent /*=NULL*/)
	: CDialogEx(CDlgUpgrade::IDD, pParent)
{

}

CDlgUpgrade::~CDlgUpgrade()
{
}

void CDlgUpgrade::DoDataExchange(CDataExchange* pDX)
{
	CDialogEx::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PROGRESS1, m_ctrlProgress);
}


BEGIN_MESSAGE_MAP(CDlgUpgrade, CDialogEx)
	ON_BN_CLICKED(IDC_BTN_LOADFILE, &CDlgUpgrade::OnBnClickedBtnLoadfile)
	ON_BN_CLICKED(IDC_BTN_UPGRADE, &CDlgUpgrade::OnBnClickedBtnUpgrade)
END_MESSAGE_MAP()


// CDlgUpgrade Ϣ


void CDlgUpgrade::OnBnClickedBtnLoadfile()
{
	// TODO:  ڴӿؼ֪ͨ
	CFileDialog dlg(TRUE, _T("*.Bin"), NULL, OFN_HIDEREADONLY | OFN_OVERWRITEPROMPT, _T("File(*.Bin)|*.Bin||"), CWnd::FromHandle(m_hWnd));//
	if (dlg.DoModal() == IDOK)
	{
		GetDlgItem(IDC_FILE_PATH)->SetWindowText(dlg.GetPathName());
	}
}


void CDlgUpgrade::OnBnClickedBtnUpgrade()
{
	// TODO:  ڴӿؼ֪ͨ
	USES_CONVERSION;
	CString strPath;
	GetDlgItem(IDC_FILE_PATH)->GetWindowText(strPath);
	if (m_pDevice == NULL || strPath.IsEmpty() == true)
	{
		return;
	}
	if (m_pDevice->GetDeviceIsOnline())
	{
		CNetSDKDevice* pNetDevice = (CNetSDKDevice*)m_pDevice;
		if (pNetDevice->m_lUserID > 0)
		{
			long lRet = AJ_NETSDK_IPC_Upgrade(pNetDevice->m_lUserID, W2A(strPath));
			if (lRet == 0)
			{
				GetDlgItem(IDC_TEXT_2)->SetWindowText(L"StateBeing upgraded");
			}
		}
		
	}
	
}

int CDlgUpgrade::SelectDevice(CDeviceBase* pDevice)
{
	if (pDevice)
	{
		GetDlgItem(IDC_DEVICE_IP)->SetWindowText(pDevice->m_szDevIP);
	}
	else
		GetDlgItem(IDC_DEVICE_IP)->SetWindowText(NULL);
	m_pDevice = pDevice;
	return 0;
}

int CDlgUpgrade::UpdateStatus(CDeviceBase* pDevice, int nStateCode)
{
	if (pDevice != m_pDevice)
	{
		return -1; 
	}
	CString strErr;
	CNetSDKDevice *pNetDevice = (CNetSDKDevice*)pDevice;
	switch (nStateCode)
	{
	case EVENT_UPLOADOK:
		strErr.Format(L"Progress100%%");
		GetDlgItem(IDC_TEXT_1)->SetWindowText(strErr);
		GetDlgItem(IDC_TEXT_2)->SetWindowText(L"StateUpgrade success, is restarting");
		break;
	case EVENT_UPLOADFAILED:
		strErr.Format(L"Progress0%%");
		GetDlgItem(IDC_TEXT_1)->SetWindowText(strErr);
		GetDlgItem(IDC_TEXT_2)->SetWindowText(L"StateUpgrade failed");
		break;
	case EVENT_UPLOAD_PROCESS:
	{
		long pos = AJ_NETSDK_IPC_GetUpgradeProgress(pNetDevice->m_lUserID);//IP_NET_DVR_GetDownloadPos
		if (pos >= 0 && pos <= 100)
		{
			strErr.Format(L"Progress, %d%%", pos);
			GetDlgItem(IDC_TEXT_1)->SetWindowText(strErr);
			m_ctrlProgress.SetPos(pos);
		}
	}		
		break;
	default:
		break;
	}
	
	return 0;

}

BOOL CDlgUpgrade::OnInitDialog()
{
	CDialogEx::OnInitDialog();

	// TODO:  ڴӶĳʼ
	m_ctrlProgress.SetRange(0, 100);
	return TRUE;  // return TRUE unless you set the focus to a control
	// 쳣:  OCX ҳӦ FALSE
}
