#pragma once
#include "PlayerWnd.h"


//////////////////////////////////////////////////////////////////////////
//
#define MAX_CHANNEL 64
//
typedef struct{
	CPlayerWnd*	wndPlayer;
	CRect		rcWnd;
}PLAYER_WND;
// CPlayerManager

class CPlayerManager : public CWnd
{
	DECLARE_DYNAMIC(CPlayerManager)

public:
	CPlayerManager();
	virtual ~CPlayerManager();
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg LRESULT OnSelectPlayerWnd(WPARAM wp, LPARAM lp);
protected:
	DECLARE_MESSAGE_MAP()
private:
	PLAYER_WND	m_wndPlayer[64];
	int			m_iCurChannelNum;//ǰʵʵĲؼĿ  ĬΪ4
	int			m_iCurSelWndIndex;//ǰѡеĴIndex
	int			m_iCurFullWndIndex;//ǰȫĴIndex
private:
	//ƲŴں
	int ReLayoutWnd();
	CRect GetChlPosition(int nChannelNo, CRect rcClient);
	CRect GetWindowRect(int iRows, int iCols, int iRowNo, int iColNo, CRect rcClient);
public:
	//ȡָŴ
	CPlayerWnd* GetPlayerWnd(unsigned int index);
	//õǰѡеĲŴ
	int	SetSelWnd(int index);
	//ȡǰѡеĲŴ
	int GetSelWnd();
	//õǰʾĲŴĿ
	int SetCurWndNum(unsigned int iWndNum);
	//ȡǰʾĲŴĿ
	int GetCurWndNum();
	//ȡ״̬ĲŴ
	int GetFreeWnd();
};


