#ifndef	__AJPLAYER_20171111_H
#define __AJPLAYER_20171111_H

#include "AjLibDef.h"

#ifdef AJPLAYER_EXPORTS
#define AJPLAYER_API __declspec(dllexport)
#else
#define AJPLAYER_API __declspec(dllimport)
#pragma comment(lib, "AjPlayer.lib")
#endif

#ifdef __cplusplus
extern "C" {
#endif

typedef struct
{
	long nWidth;
	long nHeight;
	long nStamp;
	long nType;
	long nFrameRate;
	long bIsVideo;
	int  nLinseSize[4];
}FRAME_INFO;

typedef int (CALLBACK* fDecCallBackFunction)(long nPort,char * pBuf,long nSize,FRAME_INFO * pFrameInfo, void * pUser,long nReserved2);

typedef int (CALLBACK* fQRcodeCallBackFunction)(long nPort,	char* pBuf,void * pUser);

/********************************************************
ܣʼý岥ſ⣬ڿʼʹý岥ſ֮ǰҽһΡ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_Init();

/********************************************************
ܣͷвԴһڲҪʹòʱá
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_ReleaseAll();
/************************************************************************
ܣYUVݻص
************************************************************************/
AJPLAYER_API int 	AJ_PLAYER_SetDecCallBack(LONG nPort,fDecCallBackFunction func,void * pUser);
/********************************************************
ܣʼڡ
hWndھ
ֵ>0ʾɹز	
		<=0 ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_CreatePlayer(HWND hWnd);

/********************************************************
ܣý.
nPort
isVideo:ͣ1--Ƶ0--Ƶ
pParam : ý
		 isAudio = 0ʱ
		 typedef struct __VIDEO_STREAM_PARAM
		 {
		 char codec[256];
		 int width;
		 int height;
		 int colorbits;
		 int framerate;
		 int bitrate;
		 char vol_data[256];
		 int vol_length;
		 }VIDEO_PARAM;
		 isAudio = 1ʱ
		 typedef struct  __AUDIO_STREAM_PARAM
		 {
		 char codec[256];
		 int samplerate;
		 int bitspersample;
		 int channels;
		 int framerate;
		 int bitrate;
		 }AUDIO_PARAM;
pSizeýĳȡ
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetupDecoder(int nPort,int isVideo, PBYTE pParam, DWORD pSize);

/*********************************************************
ܣýݡ

nPort
isVideoͣ0-Ƶ1-Ƶ
pBufferýݡ
nSizeݴС
pExtra һʹĽṹ
	MPEG4_VIDEO_FRAME_EXTRA
	G711_AUDIO_FRAME_EXTRA
ExtraLengthݳȡ
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_DecodeFrame(int nPort, int isVideo, BYTE* pBuffer, DWORD nSize, BYTE* pExtra, DWORD ExtraLength);

/*********************************************************
ܣȡڲŵĽƵ(YV12ʽ)ֻڲʱ
pFrameBuf ȡݡ
	  pFrameBufSize ݳ
nPort
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_ReadOneFrame(int nPort, BYTE *pFrameBuf, LONG *pFrameBufSize);

/*********************************************************
ܣ

nPort
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_ReleaseWithoutWait(int nPort);

/*********************************************************
ܣرս

nPort
isVideoͣ0-Ƶ1-Ƶ
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_CloseDecoder(int nPort,int isVideo);

/*********************************************************
ܣݻٲ

nPort
ֵ0 ʾɹ򷵻ش롣
ע⣺Ҫɾ ȵAJ_PLAYER_CloseDecoder˳ʱʹAJ_PLAYER_ReleaseAll
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_DeletePlayer(int nPort);

/*********************************************************
ܣˢ²

value1ûʱ򻹻ʾһ֡棻
	   0ûʱֱʾ
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_RefreshSurface(int value);

/********************************************************
ܣòģʽOrʵʱģʽ.

nPort
nModeģʽ0-ʵʱģʽ1-ģʽ
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetPlayMode(int nPort, int nMode);

/********************************************************
ܣȡģʽOrʵʱģʽ.

nPort
ֵģʽ0-ʵʱģʽ1-ģʽ
		-1ʾʧܡ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_GetPlayMode(int nPort);

/*********************************************************
ܣƵ

nPort
Value 0-ֹͣţ1-ʼš
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetPlayOn( int nPort, LONG Value);

/*********************************************************
ܣƵֻܿһƵ

nPort
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetAudioOn( int nPort);

/*********************************************************
ܣֹͣƵ

ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetAudioOff();

/*********************************************************
ܣ

nPort
nVolume: 
ֵ0 ʾɹ򷵻ش롣
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetVolume(int nPort,LONG nVolume);

/*********************************************************
ܣȡ

nPort
pVolume 
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_GetVolume( int nPort,LONG * pVolume);

/*********************************************************
ܣøʱǷȫʾ

nPort
bIsFullFillǷȫʾ
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetFullFillStatus(int nPort,LONG bIsFullFill);

/*********************************************************
ܣȡøʱǷȫʾ

nPort
ֵ0 ȫʾ
		1 ȫʾ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_GetFullFillStatus(int nPort);

/*********************************************************
ܣ궯

nPort
ֵ0
עⲻҪ˫¼
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_InputMouseEvent(LONG nPort,LONG nMsgType,WPARAM wp,LPARAM lp);

/*********************************************************
ܣõӷŴ״̬

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetZoomRectOn(int nPort, LONG nType);

/*********************************************************
ܣȡӷŴ״̬

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_GetZoomRectStatus(int nPort);

/*********************************************************
ܣƶģʽ

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetMotionDetectConfigOn(int nPort, LONG value);

/*********************************************************
ܣƶ״̬,

nPort
xBlocksΪУ
yBlocksΪУ
initConfigStringֻܰ01ַҳȱΪxBlocks*yBlocks1ʾѡӦ򣬰
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetMotionDetectConfig(int nPort, LONG xBlocks, LONG yBlocks, char* pConfigString);

/*********************************************************
ܣȡƶ״̬

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_GetMotionDetectConfigString(int nPort, char* pConfigString);

/*********************************************************
ܣ//ǰڲŵͼļ

nPort
FileFormat: ļʽ
0 YUVݡ
1 jpgͼƬ
2 BMPͼƬ
0-2 sDirNameʾĿ¼ Զļ
3 JPGͼƬ sDirName ʾļ
  
StoragePath FileFormat Ϊ0-2ʱΪ洢Ŀ¼FileFormat Ϊ3ʱΪ洢ļ
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SnapShot(int nPort, LONG FileFormat, char* sDirName);

/*********************************************************
ܣƵ

nPort
ֵ0 ʾɹ
*********************************************************/
//AJPLAYER_API int  AJ_PLAYER_SetAlarmStatus(int nPort, LONG alramCode, LONG duration);

/*********************************************************
ܣ¼״̬

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetRecordStatus(int nPort, LONG value);

/*********************************************************
ܣöԽ״̬

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetTalkStatus(int nPort, LONG value);

/*********************************************************
ܣǷҪʾ״̬

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetShowIco(int nPort, LONG value);

/*********************************************************
ܣ˾ʽ

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetFlipType(int nPort, LONG nType);

/*********************************************************
ܣBrightnessContrast

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetContrast(int nPort, LONG nBrightness, LONG nContrast, LONG bEnable);

/*********************************************************
ܣȡBrightnessContrast

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_GetContrast(int nPort, LONG *nBrightness, LONG *nContrast, LONG *bEnable);

/*********************************************************
ܣGamm

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetGamma(int nPort, LONG nGamma, LONG bEnable);

/*********************************************************
ܣȡGamm

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_GetGamma(int nPort, LONG* nGamma, LONG* bEnable);

/*********************************************************
ܣûС

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetBufferTick(int nPort, LONG  maxMaxSecond);

/*********************************************************
ܣ

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_ClearBufferTick(int nPort);

/*********************************************************
ܣ

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetBufferCount(int nPort, LONG nCount);

/*********************************************************
ܣǷάɨ

nPort
ֵ0 ʾɹ
*********************************************************/
AJPLAYER_API int  AJ_PLAYER_SetQRcodeScan(int nPort, int bOpen, fQRcodeCallBackFunction func,void* pUser);

/*********************************************************
ܣȡƵнĶά

nPort
ֵά
*********************************************************/
//AJPLAYER_API CString  AJ_PLAYER_GetQRcode(int nPort);

#ifdef __cplusplus
}
#endif
#endif